<?php
namespace Teknisa\TCO\Authentication;

class TcoAuthenticator{

    protected $authFunctions;

    public function __construct($authFunctions){
        $this->authFunctions  = $authFunctions;
    }

    /**
     * Run route configured function if
     * it exists, or throw a exception else.
     * User-made function should be a 
     * private function.
     * 
     * @param string $functionName Function
     * to be called.
     * @param object $request
     */
    public function run($functionName, $request){
        $callable = __NAMESPACE__.'\AuthFunctions::'.$functionName;
        if(is_callable($callable)){
            return call_user_func($callable, $request);
        } else
            throw Exception::invalidFunctionError();
    }
}