<?php
namespace Teknisa\TCO\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\GER\Utilities\Environment;
use Teknisa\GER\Utilities\DataSourceUtil;

class Tco01900UtilizacaoProdutoReceitaService extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $entityManager;
    protected $crudService;
    protected $newCode;
    
    public function __construct($crudService, $parameterBag, EntityManager $entityManager, Environment $environment, $newCode) {
      $this->entityManager = $entityManager;
      $this->environment = $environment;
      $this->crudService = $crudService;
      $this->newCode = $newCode;
    }
    
    public function retornaProdutoPorPratos($row){
        $sql = "SELECT DECODE(FILIAL,'P',:TEXTO_PADRAO,FILIAL) AS RECEITA, FILIAL, NMTABLE, DECODE(R.CDFILAUXPRAT,'P',:TEXTO_PADRAO,R.CDFILAUXPRAT) AS ARVORE, R.CDFILAUXPRAT, R.CDPRATO, PR.NMPRATO, R.CDSERVFILI, R.NMSERVICO, R.NRPADRAOQUALIDADE, R.NMPADRAOQUALIDADE, R.CDREGIAO, R.NMREGIAO, R.CDARVPROD, R.NMPRODUTO, R.CDPRODUTO, R.SGUNIDADE, R.SGUNIDPROD, R.QTPRODPRAT, R.QTBRUTAPRUNR, R.VRPEFATCOCPR, R.VRPEFATCOCPRAP, R.VRPEFATCORPR, R.VRPEFATCORPRAP, NVL(R.VRPERCDEGELO, 0.0) AS VRPERCDEGELO FROM ( SELECT 'P' AS FILIAL, 'RECEPADR' NMTABLE, RP.CDFILAUXPRAT, RP.CDPRATO, '' CDSERVFILI, '' NMSERVICO, NULL AS NRPADRAOQUALIDADE, NULL AS NMPADRAOQUALIDADE, NULL AS CDREGIAO, NULL AS NMREGIAO, PD.CDARVPROD, PD.CDPRODUTO, PD.NMPRODUTO, RP.SGUNIDADE, PD.SGUNIDADE AS SGUNIDPROD, RP.QTPRODPRAT, RP.QTBRUTAPRUNR, RP.VRPEFATCOCPR, (RP.VRPEFATCOCPR + 100) AS VRPEFATCOCPRAP, RP.VRPEFATCORPR, (100 - RP.VRPEFATCORPR) AS VRPEFATCORPRAP, RP.VRPERCDEGELO FROM PRODUTO PD, RECEPADR RP WHERE RP.CDPRATO BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIN AND (SUBSTR(PD.CDARVPROD, 1, LENGTH(:P_CDARVPROD)) = :P_CDARVPROD OR :P_CDARVPROD = 'TODOS') AND PD.CDPRODUTO = RP.CDPRODUTO AND :P_RECEPADR   = 'S' UNION ALL SELECT RF.CDFILIAL AS FILIAL, 'RECEFILI' NMTABLE, RF.CDFILAUXPRAT, RF.CDPRATO, '' CDSERVFILI, '' NMSERVICO, NULL AS NRPADRAOQUALIDADE, NULL AS NMPADRAOQUALIDADE, NULL AS CDREGIAO, NULL AS NMREGIAO, PD.CDARVPROD, PD.CDPRODUTO, PD.NMPRODUTO, RF.SGUNIDADE, PD.SGUNIDADE AS SGUNIDPROD, RF.QTPRODRECLOC QTPRODPRAT, RF.QTBRUTALOUNR AS QTBRUTAPRUNR, RF.VRPEFATCOCLO AS VRPEFATCOCPR, (RF.VRPEFATCOCLO + 100) AS VRPEFATCOCPRAP, RF.VRPEFATCORLO AS VRPEFATCORPR, (100 - RF.VRPEFATCORLO) AS VRPEFATCORPRAP, RF.VRPERCDEGELO FROM PRODUTO PD, RECEFILI RF WHERE (SUBSTR(PD.CDARVPROD, 1, LENGTH(:P_CDARVPROD)) = :P_CDARVPROD OR :P_CDARVPROD = 'TODOS') AND RF.CDPRATO BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIN AND ((RF.CDFILAUXPRAT = 'P') OR (RF.CDFILAUXPRAT = RF.CDFILIAL)) AND RF.CDPRODUTO      = PD.CDPRODUTO AND :P_RECEFILI       = 'S' AND EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :P_NRLISTASERV AND SUBSTR(CDLISTA, 1, 4) = RF.CDFILIAL) UNION ALL SELECT RS.CDFILIAL AS FILIAL, 'RECESERV' NMTABLE, RS.CDFILAUXPRAT, RS.CDPRATO, RS.CDSERVFILI, SE.NMSERVICO, NULL AS NRPADRAOQUALIDADE, NULL AS NMPADRAOQUALIDADE, NULL AS CDREGIAO, NULL AS NMREGIAO, PD.CDARVPROD, PD.CDPRODUTO, PD.NMPRODUTO, RS.SGUNIDADE, PD.SGUNIDADE AS SGUNIDPROD, RS.QTPRODRECSER AS QTPRODPRAT, RS.QTBRUTASEUNR AS QTBRUTAPRUNR, RS.VRPEFATCOCSE AS VRPEFATCOCPR, (RS.VRPEFATCOCSE + 100) AS VRPEFATCOCPRAP, RS.VRPEFATCORSE AS VRPEFATCORPR, (100 - RS.VRPEFATCORSE) AS VRPEFATCORPRAP, RS.VRPERCDEGELO FROM PRODUTO PD, SERVICO SE, RECESERV RS WHERE (SUBSTR(PD.CDARVPROD, 1, LENGTH(:P_CDARVPROD)) = :P_CDARVPROD OR :P_CDARVPROD = 'TODOS') AND (RS.CDPRATO BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIN) AND ((RS.CDFILAUXPRAT = 'P') OR (RS.CDFILAUXPRAT = RS.CDFILIAL)) AND (RS.CDFILIAL      = SE.CDFILIAL) AND (RS.CDSERVFILI    = SE.CDSERVFILI) AND RS.CDPRODUTO      = PD.CDPRODUTO AND (:P_RECESERV      = 'S') AND EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :P_NRLISTASERV AND RS.CDFILIAL = SUBSTR(CDLISTA, 1, 4) AND RS.CDSERVFILI = SUBSTR(CDLISTA, 5, 5)) UNION ALL SELECT '' AS FILIAL, 'RECEPADQUALI' NMTABLE, RQ.CDFILAUXPRAT, RQ.CDPRATO, '' AS CDSERVFILI, '' AS NMSERVICO, PQ.NRPADRAOQUALIDADE, PQ.NMPADRAOQUALIDADE, NULL AS CDREGIAO, NULL AS NMREGIAO, PD.CDARVPROD, PD.CDPRODUTO, PD.NMPRODUTO, RQ.SGUNIDADE, PD.SGUNIDADE AS SGUNIDPROD, RQ.QTPRODRECPADQ AS QTPRODPRAT, RQ.QTBRUTAPADQUNR AS QTBRUTAPRUNR, RQ.VRPEFATCOCPADQ AS VRPEFATCOCPR, (RQ.VRPEFATCOCPADQ + 100) AS VRPEFATCOCPRAP, RQ.VRPEFATCORPADQ AS VRPEFATCORPR, (100 - RQ.VRPEFATCORPADQ) AS VRPEFATCORPRAP, 0.0 AS VRPERCDEGELO FROM PRODUTO PD, RECEPADQUALI RQ, PADRAOQUALIDADE PQ WHERE (SUBSTR(PD.CDARVPROD, 1, LENGTH(:P_CDARVPROD)) = :P_CDARVPROD OR :P_CDARVPROD = 'TODOS') AND (RQ.CDPRATO BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIN) AND RQ.NRPADRAOQUALIDADE = PQ.NRPADRAOQUALIDADE AND RQ.CDPRODUTO      = PD.CDPRODUTO AND VALOR_NA_LISTA(PQ.NRPADRAOQUALIDADE, :P_PADRAOQUALI) > 0 AND (:P_RECEPADQUALI      = 'S') UNION ALL SELECT '' AS FILIAL, 'RECEREGIAO' NMTABLE, RR.CDFILAUXPRAT, RR.CDPRATO, '' AS CDSERVFILI, '' AS NMSERVICO, PQ.NRPADRAOQUALIDADE, PQ.NMPADRAOQUALIDADE, RE.CDREGIAO, RE.NMREGIAO, PD.CDARVPROD, PD.CDPRODUTO, PD.NMPRODUTO, RR.SGUNIDADE, PD.SGUNIDADE AS SGUNIDPROD, RR.QTPRODRECREGIAO AS QTPRODPRAT, RR.QTBRUTAREGIAOUNR AS QTBRUTAPRUNR, RR.VRPEFATCOCREGIAO AS VRPEFATCOCPR, (RR.VRPEFATCOCREGIAO + 100) AS VRPEFATCOCPRAP, RR.VRPEFATCORREGIAO AS VRPEFATCORPR, (100 - RR.VRPEFATCORREGIAO) AS VRPEFATCORPRAP, 0.0 AS VRPERCDEGELO FROM PRODUTO PD, RECEREGIAO RR, PADRAOQUALIDADE PQ, REGIAO RE WHERE (SUBSTR(PD.CDARVPROD, 1, LENGTH(:P_CDARVPROD)) = :P_CDARVPROD OR :P_CDARVPROD = 'TODOS') AND (RR.CDPRATO BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIN) AND RR.NRPADRAOQUALIDADE = PQ.NRPADRAOQUALIDADE AND RE.CDREGIAO = RR.CDREGIAO AND RR.CDPRODUTO      = PD.CDPRODUTO AND VALOR_NA_LISTA(RR.NRPADRAOQUALIDADE, :P_PADRAOQUALI) > 0 AND VALOR_NA_LISTA(RR.CDREGIAO, :P_REGIAO) > 0 AND (:P_RECEREGIAO      = 'S') ) R, PRATO PR WHERE PR.CDFILAUXPRAT  = R.CDFILAUXPRAT AND PR.CDPRATO = R.CDPRATO ORDER BY R.CDPRATO, R.CDFILAUXPRAT, R.FILIAL, R.CDSERVFILI, R.NRPADRAOQUALIDADE, R.CDREGIAO";
        
        $params = array(
            "P_CDPRATOINI"   => $row['P_CDPRATO1'],
            "P_CDPRATOFIN"   => $row['P_CDPRATO2'] . 'zzzzzzzzzzz',
            "P_NRLISTASERV"  => $row['P_NRLISTASERV'],
            "P_CDFILIAL"     => $row['P_CDFILIAL'],
            "P_RECEFILI"     => $row['P_RECEFILI'],
            "P_RECEPADR"     => $row['P_RECEPADR'],
            "P_RECESERV"     => $row['P_RECESERV'],
            "TEXTO_PADRAO"   => $row['TEXTO_PADRAO'],
            "P_REGIAO"       => $row['P_REGIAO'],
            "P_PADRAOQUALI"  => $row['P_PADRAOQUALI'],
            "P_RECEPADQUALI" => $row['P_RECEPADQUAL'],
            "P_RECEREGIAO"   => $row['P_RECEREGIAO'],
            "P_CDARVPROD"    => $row['P_CDARVPROD']
        );
        
        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $error) {
            throw $error;
        }
    }
    
    public function retornaFatorConversao($produto, $sgunidade, $nrorg){
        $sql = "SELECT DISTINCT SGUNIDADE, VRFATOCONVES, CDPRODUTO, NRORG
                  FROM (SELECT SGUNIDADE, VRFATOCONVES, CDPRODUTO, NRORG
                          FROM CONVPRODUTO
                         WHERE CDPRODUTO = :CDPRODUTO
                           AND NRORG       = :NRORG
                         UNION ALL
                        SELECT SGUNIDPARA         AS SGUNIDADE,
                               TO_NUMBER(VRFTCONVER) AS VRFATOCONVES,
                               :CDPRODUTO            AS CDPRODUTO,
                               NRORG
                          FROM CONVUNID
                         WHERE SGUNIDDE = :SGUNIDADE
                           AND NRORG        = :NRORG
                         UNION ALL
                        SELECT :SGUNIDADE          AS SGUNIDADE,
                               TO_NUMBER(1) AS VRFATOCONVES,
                               :CDPRODUTO               AS CDPRODUTO,
                               TO_NUMBER(:NRORG)        AS NRORG
                          FROM PARAMGERAL
                      ) CONVPRODUTO";

        $params = array(
            "CDPRODUTO" => $produto,
            "SGUNIDADE" => $sgunidade,
            "NRORG" => $nrorg
        );

        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function todosServicos($filial){
        $sql = "SELECT CDFILIAL||CDSERVFILI AS CAMPO FROM SERVICO WHERE CDFILIAL = :CDFILIAL";

        $params = array(
            "CDFILIAL" => $filial
        );

        try {
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute($params);
            $resultado = $query->fetchAll();
            $servicos = array();
            foreach($resultado as $servico){
                array_push($servicos, $servico['CAMPO']);
            }
            return $servicos;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function retornaRecePadr($cdfilauxprat, $cdprato, $cdproduto){
        $sql = "SELECT RP.CDPRODUTO, RP.SGUNIDADE,
                       RP.QTPRODPRAT AS QTLIQUIDA,
                       RP.VRPEFATCOCPR as VRPEFATCOC, RP.VRPEFATCORPR VRPEFATCOR,
                       RP.VRPEFATNUTPR AS VRPEFATNUT, RP.VRPERCDEGELO
                FROM RECEPADR RP
                WHERE RP.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RP.CDPRATO = :P_CDPRATO
                  AND RP.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetch();    
    }
    
    public function retornaReceFili($cdfilauxprat, $cdprato, $cdproduto, $cdfilial){
        $sql = "SELECT RF.CDPRODUTO, RF.SGUNIDADE,
                       RF.QTPRODRECLOC AS QTLIQUIDA,
                       RF.VRPEFATCOCLO as VRPEFATCOC, RF.VRPEFATCORLO VRPEFATCOR,
                       RF.VRPEFATNUTLO AS VRPEFATNUT, RF.VRPERCDEGELO
                FROM RECEFILI RF
                WHERE RF.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RF.CDPRATO = :P_CDPRATO
                  AND RF.CDFILIAL = :P_CDFILIAL
                  AND RF.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_CDFILIAL" => $cdfilial,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetch();    
    }
    
    public function retornaReceServ($cdfilauxprat, $cdprato, $cdproduto, $cdfilial, $cdservfili){
        $sql = "SELECT RS.CDPRODUTO, RS.SGUNIDADE,
                       RS.QTPRODRECSER AS QTLIQUIDA,
                       RS.VRPEFATCOCSE as VRPEFATCOC, RS.VRPEFATCORSE VRPEFATCOR,
                       RS.VRPEFATNUTSE AS VRPEFATNUT, RS.VRPERCDEGELO
                FROM RECESERV RS
                WHERE RS.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RS.CDPRATO = :P_CDPRATO
                  AND RS.CDFILIAL = :P_CDFILIAL
                  AND RS.CDSERVFILI = :P_CDSERVFILI
                  AND RS.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_CDFILIAL" => $cdfilial,
            "P_CDSERVFILI" => $cdservfili,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetch();    
    }
    
    public function retornaRecePadQuali($cdfilauxprat, $cdprato, $cdproduto, $nrpadraoqualidade){
        $sql = "SELECT RQ.CDPRODUTO, RQ.SGUNIDADE,
                       RQ.QTPRODRECPADQ AS QTLIQUIDA,
                       RQ.VRPEFATCOCPADQ as VRPEFATCOC, RQ.VRPEFATCORPADQ VRPEFATCOR,
                       100.0 AS VRPEFATNUT, 0.0 AS VRPERCDEGELO
                FROM RECEPADQUALI RQ
                WHERE RQ.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RQ.CDPRATO = :P_CDPRATO
                  AND RQ.NRPADRAOQUALIDADE = :P_NRPADRAOQUALIDADE
                  AND RQ.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_NRPADRAOQUALIDADE" => $nrpadraoqualidade,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetch();    
    }
    
    public function retornaReceRegiao($cdfilauxprat, $cdprato, $cdproduto, $nrpadraoqualidade, $cdregiao){
        $sql = "SELECT RR.CDPRODUTO, RR.SGUNIDADE,
                       RR.QTPRODRECREGIAO AS QTLIQUIDA,
                       RR.VRPEFATCOCREGIAO as VRPEFATCOC, RR.VRPEFATCORREGIAO VRPEFATCOR,
                       100.0 AS VRPEFATNUT, 0.0 AS VRPERCDEGELO
                FROM RECEREGIAO RR
                WHERE RR.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RR.CDPRATO = :P_CDPRATO
                  AND RR.NRPADRAOQUALIDADE = :P_NRPADRAOQUALIDADE
                  AND RR.CDREGIAO = :P_CDREGIAO
                  AND RR.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_NRPADRAOQUALIDADE" => $nrpadraoqualidade,
            "P_CDREGIAO" => $cdregiao,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetch();  
    }
    
    public function deleteRecePadr($cdfilauxprat, $cdprato, $cdproduto){
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_CDPRODUTO" => $cdproduto
        ];
        $sql = "SELECT CDPRATO FROM RECEPADR RP
                WHERE RP.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RP.CDPRATO = :P_CDPRATO
                  AND RP.CDPRODUTO <> :P_CDPRODUTO";
                  
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
        $existeOutroProduto = $query->fetch();
        if(!$existeOutroProduto) {
            throw new \Exception("N_PODE_EXCL_ULT_PROD_RECEPADR");
        }
                  
        $sql = "DELETE FROM RECEPADR RP
                WHERE RP.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RP.CDPRATO = :P_CDPRATO
                  AND RP.CDPRODUTO = :P_CDPRODUTO";
        
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function deleteReceFili($cdfilauxprat, $cdprato, $cdproduto, $cdfilial){
        $sql = "DELETE FROM RECEFILI RF
                WHERE RF.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RF.CDPRATO = :P_CDPRATO
                  AND RF.CDFILIAL = :P_CDFILIAL
                  AND RF.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_CDFILIAL" => $cdfilial,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function deleteReceServ($cdfilauxprat, $cdprato, $cdproduto, $cdfilial, $cdservfili){
        $sql = "DELETE FROM RECESERV RS
                WHERE RS.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RS.CDPRATO = :P_CDPRATO
                  AND RS.CDFILIAL = :P_CDFILIAL
                  AND RS.CDSERVFILI = :P_CDSERVFILI
                  AND RS.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_CDFILIAL" => $cdfilial,
            "P_CDSERVFILI" => $cdservfili,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params); 
    }
    
    public function deleteRecePadQuali($cdfilauxprat, $cdprato, $cdproduto, $nrpadraoqualidade){
        $sql = "DELETE FROM RECEPADQUALI RQ
                WHERE RQ.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RQ.CDPRATO = :P_CDPRATO
                  AND RQ.NRPADRAOQUALIDADE = :P_NRPADRAOQUALIDADE
                  AND RQ.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_NRPADRAOQUALIDADE" => $nrpadraoqualidade,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function deleteReceRegiao($cdfilauxprat, $cdprato, $cdproduto, $nrpadraoqualidade, $cdregiao){
        $sql = "DELETE FROM RECEREGIAO RR
                WHERE RR.CDFILAUXPRAT = :P_CDFILAUXPRAT
                  AND RR.CDPRATO = :P_CDPRATO
                  AND RR.NRPADRAOQUALIDADE = :P_NRPADRAOQUALIDADE
                  AND RR.CDREGIAO = :P_CDREGIAO
                  AND RR.CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $cdfilauxprat,
            "P_CDPRATO" => $cdprato,
            "P_NRPADRAOQUALIDADE" => $nrpadraoqualidade,
            "P_CDREGIAO" => $cdregiao,
            "P_CDPRODUTO" => $cdproduto
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params); 
    }
    
    public function updateRecePadr($valores){
        $sql = "UPDATE RECEPADR 
                       SET CDPRODUTO = :P_NOVOPRODUTO,
                       SGUNIDADE = :P_SGUNIDADE,
                       QTPRODPRAT = :P_QTLIQUIDA,
                       QTBRUTAPRUNR = :P_QTBRUTA,
                       VRPEFATCOCPR = :P_VRPEFATCOC, 
                       VRPEFATCORPR = :P_VRPEFATCOR,
                       QTBRUTAPR = :P_QTREQ,
                       QTUNIDESTPR = :P_QTREQ,
                       QTCALCNUTRPR = :P_QTCALCNUTR
                 WHERE CDFILAUXPRAT = :P_CDFILAUXPRAT
                   AND CDPRATO = :P_CDPRATO
                   AND CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_CDPRODUTO" => $valores["P_CDPRODUTO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_QTREQ" => $valores["P_QTREQ"],
            "P_QTCALCNUTR" => $valores["P_QTCALCNUTR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function updateReceFili($valores){
        $sql = "UPDATE RECEFILI
                       SET CDPRODUTO = :P_NOVOPRODUTO,
                       SGUNIDADE = :P_SGUNIDADE,
                       QTPRODRECLOC = :P_QTLIQUIDA,
                       QTBRUTALOUNR = :P_QTBRUTA,
                       VRPEFATCOCLO = :P_VRPEFATCOC, 
                       VRPEFATCORLO = :P_VRPEFATCOR,
                       QTBRUTALO = :P_QTREQ,
                       QTUNIDESTLO = :P_QTREQ,
                       QTCALCNUTRLO = :P_QTCALCNUTR
                 WHERE CDFILAUXPRAT = :P_CDFILAUXPRAT
                   AND CDPRATO = :P_CDPRATO
                   AND CDFILIAL = :P_CDFILIAL
                   AND CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_CDPRODUTO" => $valores["P_CDPRODUTO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_CDFILIAL" => $valores["P_CDFILIAL"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_QTREQ" => $valores["P_QTREQ"],
            "P_QTCALCNUTR" => $valores["P_QTCALCNUTR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function updateReceServ($valores){
        $sql = "UPDATE RECESERV
                       SET CDPRODUTO = :P_NOVOPRODUTO,
                       SGUNIDADE = :P_SGUNIDADE,
                       QTPRODRECSER = :P_QTLIQUIDA,
                       QTBRUTASEUNR = :P_QTBRUTA,
                       VRPEFATCOCSE = :P_VRPEFATCOC, 
                       VRPEFATCORSE = :P_VRPEFATCOR,
                       QTBRUTASE = :P_QTREQ,
                       QTUNIDESTSE = :P_QTREQ,
                       QTCALCNUTRSE = :P_QTCALCNUTR
                 WHERE CDFILAUXPRAT = :P_CDFILAUXPRAT
                   AND CDPRATO = :P_CDPRATO
                   AND CDFILIAL = :P_CDFILIAL
                   AND CDSERVFILI = :P_CDSERVFILI
                   AND CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_CDPRODUTO" => $valores["P_CDPRODUTO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_CDFILIAL" => $valores["P_CDFILIAL"],
            "P_CDSERVFILI" => $valores["P_CDSERVFILI"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_QTREQ" => $valores["P_QTREQ"],
            "P_QTCALCNUTR" => $valores["P_QTCALCNUTR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params); 
    }
    
    public function updateRecePadQuali($valores){
        $sql = "UPDATE RECEPADQUALI
                       SET CDPRODUTO = :P_NOVOPRODUTO,
                       SGUNIDADE = :P_SGUNIDADE,
                       QTPRODRECPADQ = :P_QTLIQUIDA,
                       QTBRUTAPADQUNR = :P_QTBRUTA,
                       VRPEFATCOCPADQ = :P_VRPEFATCOC, 
                       VRPEFATCORPADQ = :P_VRPEFATCOR,
                       CDOPERULTATU = :P_CDOPERADOR,
                       DTULTATU = SYSDATE
                 WHERE CDFILAUXPRAT = :P_CDFILAUXPRAT
                   AND CDPRATO = :P_CDPRATO
                   AND NRPADRAOQUALIDADE = :P_NRPADRAOQUALIDADE
                   AND CDPRODUTO = :P_CDPRODUTO";
        
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_CDPRODUTO" => $valores["P_CDPRODUTO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_NRPADRAOQUALIDADE" => $valores["P_NRPADRAOQUALIDADE"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_CDOPERADOR" => $valores["P_CDOPERADOR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function updateReceRegiao($valores){
        $sql = "UPDATE RECEREGIAO
                       SET CDPRODUTO = :P_NOVOPRODUTO,
                       SGUNIDADE = :P_SGUNIDADE,
                       QTPRODRECREGIAO = :P_QTLIQUIDA,
                       QTBRUTAREGIAOUNR = :P_QTBRUTA,
                       VRPEFATCOCREGIAO = :P_VRPEFATCOC, 
                       VRPEFATCORREGIAO = :P_VRPEFATCOR,
                       CDOPERULTATU = :P_CDOPERADOR,
                       DTULTATU = SYSDATE
                 WHERE CDFILAUXPRAT = :P_CDFILAUXPRAT
                   AND CDPRATO = :P_CDPRATO
                   AND NRPADRAOQUALIDADE = :P_NRPADRAOQUALIDADE
                   AND CDREGIAO = :P_CDREGIAO
                   AND CDPRODUTO = :P_CDPRODUTO";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_CDPRODUTO" => $valores["P_CDPRODUTO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_NRPADRAOQUALIDADE" => $valores["P_NRPADRAOQUALIDADE"],
            "P_CDREGIAO" => $valores["P_CDREGIAO"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_CDOPERADOR" => $valores["P_CDOPERADOR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params); 
    }
    
    public function insertRecePadr($valores){
        $sql = "INSERT INTO RECEPADR
                (CDFILAUXPRAT, CDPRATO, CDPRODUTO, 
                 SGUNIDADE, QTPRODPRAT, QTBRUTAPRUNR,
                 VRPEFATCOCPR, VRPEFATCORPR, QTBRUTAPR, QTUNIDESTPR,
                 VRPEFATNUTPR, QTCALCNUTRPR, VRPERCDEGELO)
                VALUES
                (:P_CDFILAUXPRAT, :P_CDPRATO, :P_NOVOPRODUTO, :P_SGUNIDADE, :P_QTLIQUIDA, :P_QTBRUTA,
                 :P_VRPEFATCOC, :P_VRPEFATCOR, :P_QTREQ, :P_QTREQ,
                 100.0, :P_QTCALCNUTR, 0)";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_QTREQ" => $valores["P_QTREQ"],
            "P_QTCALCNUTR" => $valores["P_QTCALCNUTR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function insertReceFili($valores){
        $sql = "INSERT INTO RECEFILI
                (CDFILAUXPRAT, CDPRATO, CDPRODUTO, CDFILIAL, 
                 SGUNIDADE, QTPRODRECLOC, QTBRUTALOUNR,
                 VRPEFATCOCLO, VRPEFATCORLO, QTBRUTALO, QTUNIDESTLO,
                 VRPEFATNUTLO, QTCALCNUTRLO, VRPERCDEGELO)
                VALUES
                (:P_CDFILAUXPRAT, :P_CDPRATO, :P_NOVOPRODUTO, :P_CDFILIAL, :P_SGUNIDADE, :P_QTLIQUIDA, :P_QTBRUTA,
                 :P_VRPEFATCOC, :P_VRPEFATCOR, :P_QTREQ, :P_QTREQ,
                 100.0, :P_QTCALCNUTR, 0)";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_CDFILIAL" => $valores["P_CDFILIAL"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_QTREQ" => $valores["P_QTREQ"],
            "P_QTCALCNUTR" => $valores["P_QTCALCNUTR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function insertReceServ($valores){
        $sql = "INSERT INTO RECESERV
                (CDFILAUXPRAT, CDPRATO, CDPRODUTO, CDFILIAL, CDSERVFILI,
                 SGUNIDADE, QTPRODRECSER, QTBRUTASEUNR,
                 VRPEFATCOCSE, VRPEFATCORSE, QTBRUTASE, QTUNIDESTSE,
                 VRPEFATNUTSE, QTCALCNUTRSE, VRPERCDEGELO)
                VALUES
                (:P_CDFILAUXPRAT, :P_CDPRATO, :P_NOVOPRODUTO, :P_CDFILIAL, :P_CDSERVFILI, 
                 :P_SGUNIDADE, :P_QTLIQUIDA, :P_QTBRUTA,
                 :P_VRPEFATCOC, :P_VRPEFATCOR, :P_QTREQ, :P_QTREQ,
                 100.0, :P_QTCALCNUTR, 0)";
        $params = [
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_CDFILIAL" => $valores["P_CDFILIAL"],
            "P_CDSERVFILI" => $valores["P_CDSERVFILI"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_QTREQ" => $valores["P_QTREQ"],
            "P_QTCALCNUTR" => $valores["P_QTCALCNUTR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params); 
    }
    
    public function insertRecePadQuali($valores){
        $nrrecepadquali = $this->newCode->getCodeByTableName('RECEPADQUALI', $valores['P_NRORG'], 1, 10, true);
        $sql = "INSERT INTO RECEPADQUALI
                (NRRECEPADQUALI, CDFILAUXPRAT, CDPRATO, CDPRODUTO, NRPADRAOQUALIDADE,
                 SGUNIDADE, QTPRODRECPADQ, QTBRUTAPADQUNR,
                 VRPEFATCOCPADQ, VRPEFATCORPADQ,
                 NRORG, NRORGINCLUSAO, NRORGULTATU,
                 CDOPERINCLUSAO, CDOPERULTATU,
                 DTINCLUSAO, DTULTATU)
                VALUES
                (:P_NRRECEPADQUALI, :P_CDFILAUXPRAT, :P_CDPRATO, :P_NOVOPRODUTO, :P_NRPADRAOQUALIDADE, 
                 :P_SGUNIDADE, :P_QTLIQUIDA, :P_QTBRUTA,
                 :P_VRPEFATCOC, :P_VRPEFATCOR,
                 :P_NRORG, :P_NRORG, :P_NRORG,
                 :P_CDOPERADOR, :P_CDOPERADOR,
                 SYSDATE, SYSDATE)";
        $params = [
            "P_NRRECEPADQUALI" => $nrrecepadquali,
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_NRPADRAOQUALIDADE" => $valores["P_NRPADRAOQUALIDADE"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_NRORG" => $valores["P_NRORG"],
            "P_CDOPERADOR" => $valores["P_CDOPERADOR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);  
    }
    
    public function insertReceRegiao($valores){
        $nrreceregiao = $this->newCode->getCodeByTableName('RECEREGIAO', $valores['P_NRORG'], 1, 10, true);
        $sql = "INSERT INTO RECEREGIAO
                (NRRECEREGIAO, CDFILAUXPRAT, CDPRATO, CDPRODUTO,
                 NRPADRAOQUALIDADE, CDREGIAO,
                 SGUNIDADE, QTPRODRECREGIAO, QTBRUTAREGIAOUNR,
                 VRPEFATCOCREGIAO, VRPEFATCORREGIAO,
                 NRORG, NRORGINCLUSAO, NRORGULTATU,
                 CDOPERINCLUSAO, CDOPERULTATU,
                 DTINCLUSAO, DTULTATU)
                VALUES
                (:P_NRRECEREGIAO, :P_CDFILAUXPRAT, :P_CDPRATO, :P_NOVOPRODUTO,
                 :P_NRPADRAOQUALIDADE, :P_CDREGIAO,
                 :P_SGUNIDADE, :P_QTLIQUIDA, :P_QTBRUTA,
                 :P_VRPEFATCOC, :P_VRPEFATCOR,
                 :P_NRORG, :P_NRORG, :P_NRORG,
                 :P_CDOPERADOR, :P_CDOPERADOR,
                 SYSDATE, SYSDATE)";
        $params = [
            "P_NRRECEREGIAO" => $nrreceregiao,
            "P_CDFILAUXPRAT" => $valores["P_CDFILAUXPRAT"],
            "P_CDPRATO" => $valores["P_CDPRATO"],
            "P_NOVOPRODUTO" => $valores["P_NOVOPRODUTO"],
            "P_NRPADRAOQUALIDADE" => $valores["P_NRPADRAOQUALIDADE"],
            "P_CDREGIAO" => $valores["P_CDREGIAO"],
            "P_SGUNIDADE" => $valores["P_SGUNIDADE"],
            "P_QTLIQUIDA" => $valores["P_QTLIQUIDA"],
            "P_QTBRUTA" => $valores["P_QTBRUTA"],
            "P_VRPEFATCOC" => $valores["P_VRPEFATCOC"],
            "P_VRPEFATCOR" => $valores["P_VRPEFATCOR"],
            "P_NRORG" => $valores["P_NRORG"],
            "P_CDOPERADOR" => $valores["P_CDOPERADOR"]
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params); 
    }
}